| Flutter Impeller |

Public Member Functions | Protected Member Functions | List of all members
impeller::FillPathSourceGeometry Class Referenceabstract

An abstract Geometry base class that produces fillable vertices for the interior of any |PathSource| provided by the type-specific subclass. More...

`#include <fill_path_geometry.h>`

Inheritance diagram for impeller::FillPathSourceGeometry:

## Public Member Functions
| ~FillPathSourceGeometry () override
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
Public Member Functions inherited from impeller::Geometry
virtual | ~Geometry ()
virtual bool | IsAxisAlignedRect () const
virtual bool | CanApplyMaskFilter () const
virtual Scalar | ComputeAlphaCoverage (const Matrix &transform) const

## Protected Member Functions
| FillPathSourceGeometry (std::optional< Rect > inner_rect)
virtual const PathSource & | GetSource () const =0

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::unique_ptr< Geometry > | MakeFillPath (const flutter::DlPath &path, std::optional< Rect > inner_rect=std::nullopt)
static std::unique_ptr< Geometry > | MakeStrokePath (const flutter::DlPath &path, const StrokeParameters &stroke={})
static std::unique_ptr< Geometry > | MakeCover ()
static std::unique_ptr< Geometry > | MakeRect (const Rect &rect)
static std::unique_ptr< Geometry > | MakeOval (const Rect &rect)
static std::unique_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::unique_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::unique_ptr< Geometry > | MakeFilledArc (const Rect &oval_bounds, Degrees start, Degrees sweep, bool include_center)
static std::unique_ptr< Geometry > | MakeStrokedArc (const Rect &oval_bounds, Degrees start, Degrees sweep, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::unique_ptr< Geometry > | MakeRoundSuperellipse (const Rect &rect, Scalar corner_radius)
static Scalar | ComputeStrokeAlphaCoverage (const Matrix &entity, Scalar stroke_width)
| Compute an alpha value to simulate lower coverage of fractional pixel strokes. More...
static GeometryResult | ComputePositionGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)

## Detailed Description

An abstract Geometry base class that produces fillable vertices for the interior of any |PathSource| provided by the type-specific subclass.

Definition at line 19 of file fill_path_geometry.h.

## Constructor & Destructor Documentation

## ◆ ~FillPathSourceGeometry()

impeller::FillPathSourceGeometry::~FillPathSourceGeometry | ( |  | ) |
| override

Definition at line 18 of file fill_path_geometry.cc.

18 {}

## ◆ FillPathSourceGeometry()

impeller::FillPathSourceGeometry::FillPathSourceGeometry | ( | std::optional< Rect > | inner_rect | ) |
| explicitprotected

Definition at line 15 of file fill_path_geometry.cc.

16 : inner_rect_(inner_rect) {}

## Member Function Documentation

## ◆ CoversArea()

bool impeller::FillPathSourceGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| overridevirtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Reimplemented in impeller::FillRoundRectGeometry.

Definition at line 83 of file fill_path_geometry.cc.

84 {
85 if (!inner_rect_.has_value()) {
86 return false;
87 }
88 if (!transform.IsTranslationScaleOnly()) {
89 return false;
90 }
91 Rect coverage = inner_rect_->TransformBounds(transform);
92 return coverage.Contains(rect);
93 }
transform
Matrix transform
Definition: gaussian_blur_filter_contents.cc:312
impeller::Rect
TRect< Scalar > Rect
Definition: rect.h:788

References impeller::TRect< T >::Contains(), and transform.

## ◆ GetSource()

virtual const PathSource& impeller::FillPathSourceGeometry::GetSource | ( |  | ) | const
| protectedpure virtual

The PathSource object that will be iterated to produce the filled vertices.

Implemented in impeller::FillRoundRectGeometry, impeller::FillDiffRoundRectGeometry, impeller::FillPathGeometry, and impeller::FillPathFromSourceGeometry.

The documentation for this class was generated from the following files:

- impeller/entity/geometry/fill_path_geometry.h
- impeller/entity/geometry/fill_path_geometry.cc